﻿Imports System.Threading
Imports System.Collections.Generic
Imports System.Collections.ObjectModel
Imports ThinkGeo.MapSuite.Core
Imports ThinkGeo.MapSuite.WpfDesktopEdition

#Const MapSuiteVersion = 5.0

Class Window1
  Private Sub WpfMap1_Loaded(ByVal sender As Object, ByVal e As System.Windows.RoutedEventArgs) Handles WpfMap1.Loaded
    WpfMap1.MapUnit = GeographyUnit.DecimalDegree
    WpfMap1.CurrentExtent = New RectangleShape(-50, 16, 66, -50)

    Dim worldMapKitDesktopOverlay As New WorldMapKitWmsWpfOverlay()
    WpfMap1.Overlays.Add(worldMapKitDesktopOverlay)

    Dim PointsOverlay As New LayerOverlay
#If MapSuiteVersion = 4.5 Then
    PointsOverlay.WrapDatelineMode = ThinkGeo.MapSuite.WpfDesktopEdition.WrapDatelineMode.WrapDateline 'MapSuite Version 4.5
#ElseIf MapSuiteVersion = 5.0 Then
    PointsOverlay.WrappingMode = WrappingMode.WrapDateline 'MapSuite Version 5.0
#End If
    PointsOverlay.TileType = TileType.MultipleTile

    Dim InMemoryPointsFeatureLayer As New InMemoryFeatureLayer()
    InMemoryPointsFeatureLayer.ZoomLevelSet.ZoomLevel01.DefaultPointStyle = New PointStyle(PointSymbolType.Circle, New GeoSolidBrush(GeoColor.SimpleColors.Red), 18)
    InMemoryPointsFeatureLayer.ZoomLevelSet.ZoomLevel01.ApplyUntilZoomLevel = ApplyUntilZoomLevel.Level20
    PointsOverlay.Layers.Add("InMemoryPointsFeatureLayer", InMemoryPointsFeatureLayer)

    WpfMap1.Overlays.Add("PointsOverlay", PointsOverlay)

    'Plot a point
    Dim newFeature As New Feature(New PointShape(-4, 40))
    InMemoryPointsFeatureLayer.InternalFeatures.Add(newFeature)
    InMemoryPointsFeatureLayer.BuildIndex()

    WpfMap1.Refresh()

    WpfMap1.CenterAt(New PointShape(-4, 40))

  End Sub

  Private Sub WpfMap1_MouseUp(ByVal sender As Object, ByVal e As System.Windows.Input.MouseButtonEventArgs) Handles WpfMap1.MouseUp
    Call FuckItUp()
  End Sub

  Private Delegate Sub FuckItUpDelegate()
  Private Sub FuckItUp()
    If Me.Dispatcher.CheckAccess() Then
      Dim PointsOverlay As LayerOverlay = WpfMap1.Overlays("PointsOverlay")
      Dim InMemoryPointsFeatureLayer As InMemoryFeatureLayer = PointsOverlay.Layers("InMemoryPointsFeatureLayer")

      InMemoryPointsFeatureLayer.InternalFeatures.Clear()
      'InMemoryPointsFeatureLayer.BuildIndex()

      PointsOverlay.Refresh() 'This should not throw an exception
    Else
      Me.Dispatcher.Invoke(New FuckItUpDelegate(AddressOf FuckItUp))
    End If
  End Sub
End Class
